/* ©  Copyright Steve Simon, 2013 */
#include <u.h>
#include <libc.h>
#include <ctype.h>
#include <auth.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jira.h"

int
upd_assignee(Sess *s, char *issue, char *str)
{
	char *p;
	Jvalue *v;

	p = smprint("{ \"fields\" : { \"assignee\" : { \"name\" : \"%s\"} } }", str);
	v = exch(s, p, "rest/api/%s/issue/%U", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot update assignee, %r\n", issue);
		return -1;
	}
	json_free(v);
	return 0;
}

int
upd_issuetype(Sess *s, char *issue, char *str)
{
	char *p;
	Jvalue *v;

	p = smprint("{ \"fields\" : { \"issuetype\" : { \"name\" : \"%s\"} } }", str);
	v = exch(s, p, "rest/api/%s/issue/%U", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot update issue type, %r\n", issue);
		return -1;
	}
	json_free(v);
	return 0;
}

int
upd_priority(Sess *s, char *issue, char *str)
{
	char *p;
	Jvalue *v;

	p = smprint("{ \"fields\" : { \"priority\" : { \"id\" : \"%s\"} } }", str);
	v = exch(s, p, "rest/api/%s/issue/%U", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot update priority, %r\n", issue);
		return -1;
	}
	json_free(v);
	return 0;
}

int
upd_description(Sess *s, char *issue, char *str)
{
	char *p;
	Jvalue *v;

	p = smprint("{ \"fields\" : { \"description\" : \"%s\" } }", str);
	v = exch(s, p, "rest/api/%s/issue/%U", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot update description, %r\n", issue);
		return -1;
	}
	json_free(v);
	return 0;
}

int
upd_summary(Sess *s, char *issue, char *str)
{
	char *p;
	Jvalue *v;

	p = smprint("{ \"fields\" : { \"summary\" : \"%s\" } }", str);
	v = exch(s, p, "rest/api/%s/issue/%U", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot update summary, %r\n", issue);
		return -1;
	}
	json_free(v);
	return 0;
}

int
new_comment(Sess *s, char *issue, char *str)
{
	char *p;
	Jvalue *v;

fprint(2, "create comment in issue=%s contents='%s'\n", issue, str);

	p = smprint("{ \"body\" : \"%s\"}", str);
	v = exch(s, p, "rest/api/%s/issue/%U/comment", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot create a comment, %r\n", issue);
		return -1;
	}
	json_free(v);
	return 0;
}

int
add_transition(Sess *s, char *issue, char *str)
{
	int n, id;
	char *p, *a[8];
	Jvalue *v;

	fprint(2, "add_transition: issue=%s val==%s\n", issue, str);


	if((v = exch(s, nil, "rest/api/%s/issue/%U/transitions", s->api, issue)) == nil){
		warn("%s cannot get valid transition list, %r\n", issue);
		return -1;
	}

// analysis of valid transitions

	json_free(v);


/*
	if((n = tokenize(str, a, nelem(a))) != 1){
		werrstr("upd_transition: bad message format");
		return -1;
	}

	p = nil;
	p = smprint("{ \"transition\" : %s, \"fields\" : { \"resolution\" : \"%s\" }, \"comment\" : \"%s\" }",
		id, resolution, comment);
	v = exch(s, p, "rest/api/%s/issue/%U/transitions", s->api, issue);
	free(p);
	if(v == nil){
		warn("%s cannot create a transitions, %r\n", issue);
		return -1;
	}
	json_free(v);
*/
	return 0;
}

